<template>
  <v-row justify="center" align="center">
    <v-col cols="12" sm="10" md="10">
      <v-card>
        <v-card-title class="headline">
          Casino App
        </v-card-title>
        <v-card-text class="py-3 font-weight-black">
          <v-row>
            <v-col v-for="(rollCol,rollIndex) in colsIndex" :key="`rolls_index_${rollIndex}`" cols="12" md="4">
              <v-sheet class="rounded py-5 text-center" color="white" :height="300">
                <v-row
                  class="fill-height"
                  align="center"
                  justify="center"
                >
                  <v-progress-circular
                    v-if="waitingLoading[rollIndex].status"
                    :size="70"
                    :width="7"
                    color="purple"
                    indeterminate
                  />
                  <v-img
                    v-else
                    :width="70"
                    :src="`./symbols/${symbols[rollCol].icon}`"
                    :title="symbols[rollCol].name"
                    :alt="symbols[rollCol].name"
                  />
                </v-row>
              </v-sheet>
            </v-col>
          </v-row>
        </v-card-text>
        <v-card-actions class="px-5 py-3">
          <span class="font-weight-bold">Points :</span><span>{{ points }}</span>
          <v-btn
            data-testId="start-game"
            class="ml-4"
            color="success"
            :disabled="points < 1"
            @click="start"
          >
            Start
          </v-btn>
          <v-spacer />
          <v-hover v-slot="{ hover }">
            <v-btn
              color="primary"
              :style="hover ? cashHover() : null"
              :disabled="!cashStatus"
            >
              Cash Out
            </v-btn>
          </v-hover>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
export default {
  name: 'IndexPage',
  data () {
    return {
      points: 10,
      rollCounter: 0,
      index: 0,
      symbols: [
        {
          name: 'Cherry',
          icon: 'cherry.svg',
          reward: 10
        },
        {
          name: 'Lemon',
          icon: 'lemon.svg',
          reward: 10
        },
        {
          name: 'Orange',
          icon: 'orange.svg',
          reward: 30
        },
        {
          name: 'Watermelon',
          icon: 'watermelon.svg',
          reward: 40
        }
      ],
      colsIndex: [
        0, 1, 2
      ],
      waitingLoading: [
        {
          status: false,
          time: 1000,
          timeOut: null
        },
        {
          status: false,
          time: 2000,
          timeOut: null
        },
        {
          status: false,
          time: 3000,
          timeOut: null
        }
      ],
      wining: false,
      cashStatus: true
    }
  },
  methods: {
    start () {
      /**
       * Loading true
       * Wining false
       */
      for (const waitingIndex in this.waitingLoading) {
        this.waitingLoading[waitingIndex].status = false
      }
      this.wining = false
      /**
       * Start roll
       */
      this.roll()
      /**
       * Cheat
       */
      if (this.wining) {
        if (this.points >= 40 && this.points < 60) {
          const random = Math.random()
          if (random <= 0.3) {
            this.roll()
          }
        } else if (this.points >= 60) {
          const random = Math.random()
          if (random <= 0.6) {
            this.roll()
          }
        }
      }

      /**
       * Re-check wining after cheat
       * Set reward points
       */
      if (this.wining) {
        const symbolIndex = this.colsIndex[0]
        const reward = this.symbols[symbolIndex].reward
        this.points += reward
      } else {
        this.points--
      }
      /**
       * Increase rollCounter
       */
      this.rollCounter++
      /**
       * Set loading time out
       */
      for (const waitingIndex in this.waitingLoading) {
        this.waitingLoading[waitingIndex].status = true
        this.waitingLoading[waitingIndex].timeOut = setTimeout(() => {
          this.waitingLoading[waitingIndex].status = false
          clearTimeout(this.waitingLoading[waitingIndex].timeOut)
        }, this.waitingLoading[waitingIndex].time)
      }
    },
    roll () {
      const symbolsLength = this.symbols.length
      const winingCounter = []
      for (let i = 0; i < this.colsIndex.length; i++) {
        this.colsIndex[i] = this.getRandomInt(symbolsLength)
        if (i > 0 && this.colsIndex[i] === this.colsIndex[i - 1]) {
          winingCounter.push(true)
        }
      }
      this.wining = winingCounter.length === (this.colsIndex.length - 1)
    },
    getRandomInt (max) {
      return Math.floor(Math.random() * max)
    },
    cashHover () {
      const random = Math.random()
      if (random <= 0.5) {
        this.cashStatus = false
      }
      if (random <= 0.4) {
        if (this.getRandomInt(2) > 0) { return 'margin-right: 300px' } else { return 'margin-left: 300px' }
      }
    }
  }
}
</script>
